// ValRespSingleCertDetails.h: interface for the CValRespSingleCertDetails class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VALRESPSINGLECERTDETAILS_H__98CB56F2_9DFA_11D3_80E9_00A0C9E2EA8A__INCLUDED_)
#define AFX_VALRESPSINGLECERTDETAILS_H__98CB56F2_9DFA_11D3_80E9_00A0C9E2EA8A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "VString.h"
#include "Certificate.h"
#include "Validator.h"
#include "ValHdl.h"


class CExtensions;

class __exportVTKC CValRespSingleCertDetails  
{
	// Following friends are only function that can set CValRespSingleCertDetails data

	friend void CCertificate::CRLValidate(const CContext& context, Vtk_uint32 *pStatus,
							   CValRespDetails *pRespDetails /*= NULL*/,
							   CValRespSingleCertDetails *pCertDetails/*=NULL*/) const;

	friend void CValidator::GetRevStatus(const CContext& context, const CCertificate& cert,
						      const CCertificate& issuerCert, Vtk_uint32 *pStatus, 
							  CValRespDetails *pRespDetails /*=NULL*/,
							  CValRespSingleCertDetails *pCertDetails /*=NULL*/) const;

	friend void CValHdl::GetRevStatus(const CContext& context, Vtk_uint32 *pStatus, 
							  CValRespDetails *pRespDetails /*=NULL*/,
							  CValRespSingleCertDetails *pCertDetails /*=NULL*/) const;

private:

	// Temporary (until necessary functions from Toolkit are provided)
	// make copy constructor and assign operator not available
	CValRespSingleCertDetails(const CValRespSingleCertDetails& obj);
	CValRespSingleCertDetails& operator=(const CValRespSingleCertDetails& obj);


public:
	CValRespSingleCertDetails();
	virtual ~CValRespSingleCertDetails();

	// Check if structure Vtk_ValRespSingleCertDetails was initialized
	bool IsNull() const { return m_pCertDetails == NULL ? true : false; }

	// Accessors to Vtk_ValRespSingleCertDetails data structure
	enum Vtk_ValidationMech ValidationMech() const;
	Vtk_uint32 CertStatus() const;
	VString CertStringStatus() const;
	time_t ThisUpdate() const;
	time_t NextUpdate() const;
	time_t RevocationTime() const;
	enum Vtk_RevocationReason RevocationReason() const;

	// Print CValRespDetails object to standard output 
	void Print(ostream& os, const CContext& context) const;


protected:

	// Detailed revocation information for a single certificate.
	Vtk_ValRespSingleCertDetails *m_pCertDetails;
};

#endif // !defined(AFX_VALRESPSINGLECERTDETAILS_H__98CB56F2_9DFA_11D3_80E9_00A0C9E2EA8A__INCLUDED_)
